macro
: 1+ $40 1, ;              : 1- $48 1, ;
: swap $0687 2, ;          : drop $ad 1, ; 
: nip $04c683 3, ;         : false $f9 1, ;
: true $f8 1, ;            : vector $90909090 , $90 1, ;

forth
: swap swap ;              : drop drop ;
: nip nip ;                : dup [ $fc4689 3, $fc768d 3, ] ;
: and [ $0623 2, ] nip ;   : or [ $060b 2, ] nip ;
: xor [ $0633 2, ] nip ;   : not -1 xor ;          

: @ [ $008b 2, ] ;         : ! [ $adc289 3, $ad0289 3, ] ;
: c@ @ $ff and ;           : c! [ $adc289 3, $ad0288 3, ] ;
: w! [ $068bc289 , $8b028966 , $768d0446 , $08 1, ] ;
: w@ @ $ffff and ;

: hex 16 base ! ;          : decimal 10 base ! ;
: binary 2 base ! ;        : octal 8 base ! ;

: + [ $0603 2, ] nip ;     : * [ $26f7 2, ] nip ;
: - [ $ad0629 3, ] ;       : negate -1 * ;
: /mod [ $c389 2, $99ad 2, $fbf7 2, ] dup [ $d089 2, ] ;
: / /mod drop ;            : mod /mod nip ;
: 1+ 1+ ;                  : 1- 1- ;

: wsparse 32 parse ;       : lnparse 10 parse ;

: >> [ $c189 2, $d3ad 2, $e8 1, ] ;
: << [ $c189 2, $d3ad 2, $e0 1, ] ;

: here h0 @ ;

macro
: f: wsparse find compile ;
: m: wsparse mfind compile ;
: ['] wsparse find m: literal ;

: : wsparse entry ;        : c: m: ['] ['] compile compile ;

: >r $ad50 2, ;            : r> c: dup $58 1, ;
: r m: r> $50 1, ;

: prior last @ >r last @ @ last ! wsparse find compile r> last ! ;

: repeat here ;            : again compile m: ;; ;
: next m: r> $48 1, $c009 2, $850f 2, here - 4 - , $ad 1, ;
: for here m: >r ;

: (if) $063b 2, $adad 2, 1, here 0 1, ;
: <>if $74 m: (if) ;       : =if  $75 m: (if) ;
: <if  $7e m: (if) ;       : >if  $7d m: (if) ;
: ?if  $72 1, here 0 1, ;  : then dup here swap - 1- swap c! $90 1, ;

forth
: cells 4 * ;              : cell+ 4 + ;         : cell- 4 - ;
: later r> r> swap >r >r ; : exit, $c3 1, ;
: create: wsparse entry ;  : variable 0 : variable: create , ;
: rot >r swap r> swap ;    : -rot swap >r swap r> ;
: over >r dup r> swap ;    : tuck dup -rot ;
: 2dup over over ;         : 2drop drop drop ;
: ' wsparse find ;         : alias create: last @ cell+ ! ;
: execute >r ;             : 0; dup 0 =if r> 2drop then ;
: literal, m: literal ;    : constant create: literal, exit, ;
: +! dup @ rot + swap ! ;  : -! dup @ rot - swap ! ;
: allot h0 +! ;            : is here swap ' h0 ! compile m: ;; h0 ! ;
: devector $90909090 ' $90 over c! 1+ ! ;

create list 5 cells allot
: loc: 1 list +! list @ cells list + last @ swap ! ;
: ;loc list @ cells list + @ last ! 1 list -! ;

: fill swap for swap 2dup c! 1+ swap next 2drop ;
: move for swap 2dup c@ swap c! 1+ swap 1+ next 2drop ;
: pad here 1024 + ;        : >pad dup >r pad swap move pad r> ;

: " '" parse dup 0; drop >pad ;
: ." " type ;
loc:
  : string, here 20 + over swap literal, literal, ;
  here ] string, $eb 1, dup 1, dup >r here swap move r> allot ;
;loc alias $,

macro
: s" " $, ;                : ." " $, c: type ;
: < '> parse $, c: eval ;

forth
: . dup 0 <if '- emit negate then : u. # : space 32 emit ;
: cr 10 emit ;

reset
: ui vector ;
: exit < devector ui > ;
here ] repeat ui interpret again ;
macro
: ( ') parse 2drop ;
forth
: |  lnparse 2drop ;

loc:
  variable size
  : place here swap move here ;
  : make dup -rot place swap dup allot 0 1, 1+ size +! ;
  : free size @ negate allot 0 size ! ;
  here ] make later free ;
;loc alias zt

: words last repeat @ 0; dup 9 + dup 1- c@ type space again ;
: .s 10 for r 1- [ $86048b 3, ] . next cr ;
108 constant version
: ? ." RETRO " version 100 /mod # '. emit # cr ;
loc:
  from kernel32.dll
  2 import SetConsoleCursorPosition
  2 import SetConsoleTextAttribute
  2 import GetConsoleScreenBufferInfo
  1 import GetStdHandle
  -11 GetStdHandle : handle literal ;
  : attr@ handle here GetConsoleScreenBufferInfo drop here 8 + w@ ;
  : attr! handle swap SetConsoleTextAttribute    drop ;
  : home  handle 0    SetConsoleCursorPosition   drop ;
  ' home  ' attr@  ' attr!
;loc  alias attr!  alias attr@  alias home

: clear home 80 30 * for space next home ;
: (fg) attr@ $fffffff0 and + attr! ;
: (bg) attr@ $ffffff0f and + attr! ;
: bold attr@ 8 or attr! ;
: black 0 (fg) ;   : blue 1 (fg)  ;  : green 2 (fg) ;
: cyan 3 (fg) ;    : red 4 (fg) ;    : magenta 5 (fg) ;
: yellow 6 (fg) ;  : white 7 (fg) ;

: onBlack 0 (bg) ;     : onBlue $10 (bg)  ;  : onGreen $20 (bg) ;
: onCyan $30 (bg) ;    : onRed $40 (bg) ;    : onMagenta $50 (bg) ;
: onYellow $60 (bg) ;  : onWhite $70 (bg) ;

: normal white onBlack clear ;
variable blk               64 variable: #blks
: (block) blk @ : block 512 * there + ;
: (line) 64 * (block) + ;

: p 1 blk -! ;             : n 1 blk +! ;
: d (line) 64 32 fill ;    : x (block) 512 32 fill ;
: eb (block) 512 eval ;    : el (line) 64 eval ;
: e 8 for 8 r - el next ;  : s blk ! ;
: i 0 swap : ia (line) + lnparse rot swap move ;
: \ 1 s e ;                : \f there #blks @ 512 * eval ; 

: use vector ;             : blocks #blks ! ;
: load use : r vector ;    : w vector ;

: new there #blks @ 512 * 32 fill 0 s ;
new
loc:
 : .block ." Block: " blk @ . ." of " #blks @ . ; 
 : status .block ."   Stack: " .s ;
 : row dup 64 type 64 + cr ;
 : .line 8 swap - . ;
 : rows 8 for r .line row next ;
 : x--- 4 for ." +---:---+---:---" next ;
 : --- space space x--- cr ;
 here ] --- blk @ block rows drop --- status ;
;loc alias v
loc:
  create fname 256 allot
  : erase fname 256 0 fill ;
  here is use ] erase wsparse fname swap move ;
  variable #size              : size #blks @ 512 * #size ! ;

  from kernel32.dll
  1 import CloseHandle        3 import OpenFile
  5 import ReadFile           5 import WriteFile

  variable current
  : close current @ CloseHandle drop ;

  : open  fname here $0000 OpenFile current ! size ;
  here is r ] new open current @ there #size @ here 0 ReadFile drop close ;

  : open fname here $1001 OpenFile current ! size ;
  here is w ] open current @ there #size @ here 0 WriteFile drop close ;
;loc
loc:
  : prelude >in @ here last @ ;
  : postlude last ! h0 ! >in ! ;
  : attempt 0 import ;
  : make here 5 + @ @ create , ;
  here ] prelude attempt postlude make ;
;loc alias vimport

loc:
 : erase 160 for space next ;
 : clr home 10 for cr next erase home ;
 : display clr v ;
 here ] clear display ['] display < is ui > ;
;loc alias edit
